unit UnitAPP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SerIICSlv, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    SerIICSlv: TSerIICSlv;
    StatusBar1: TStatusBar;
    Panel2: TPanel;
    GroupBox1: TGroupBox;
    BtnCOM: TButton;
    InComNr: TEdit;
    UpDown1: TUpDown;
    GroupBox2: TGroupBox;
    BtnGetSlvAdr: TButton;
    BtnSSlvAdr: TButton;
    BtnCSlvAdr: TButton;
    InSlvAdr: TEdit;
    Label1: TLabel;
    GroupBox3: TGroupBox;
    Panel1: TPanel;
    RBNoInt: TRadioButton;
    RBInt1: TRadioButton;
    RBInt2: TRadioButton;
    EditWrite: TEdit;
    BtnWData: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    Label2: TLabel;
    procedure BtnCOMClick(Sender: TObject);
    procedure SerIICSlvOpen(Sender: TObject; Comport: Byte);
    procedure SerIICSlvClose(Sender: TObject);
    procedure SerIICSlvTimeOut(Sender: TObject);
    procedure BtnGetSlvAdrClick(Sender: TObject);
    procedure BtnSSlvAdrClick(Sender: TObject);
    procedure BtnCSlvAdrClick(Sender: TObject);
    procedure SerIICSlvSlvAdrOP(Sender: TObject; OP: Byte);
    procedure SerIICSlvSlvAdrRead(Sender: TObject; pSlvAdr: Byte);
    procedure SerIICSlvI2CDataAvail(Sender: TObject; I2CData: TI2CData);
    procedure BtnWDataClick(Sender: TObject);
    procedure SerIICSlvWriteI2CRegs(Sender: TObject; IntType: Byte);
    procedure InSlvAdrExit(Sender: TObject);
    procedure InSlvAdrKeyPress(Sender: TObject; var Key: Char);
    procedure EditWriteKeyPress(Sender: TObject; var Key: Char);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
  private
    { Private declarations }
  public
    { Public declarations }
    Procedure HexKey(Var Key : Char);
  end;

var
  Form1: TForm1;
  State : Boolean;

implementation

{$R *.DFM}

procedure TForm1.BtnCOMClick(Sender: TObject);
begin
  State := NOT State;
  if InComNr.Text <> '' then
    SerIICSlv.Comport := StrToInt(InComNr.Text);
  SerIICSlv.FConnect(State);
end;

procedure TForm1.SerIICSlvOpen(Sender: TObject; Comport: Byte);
begin
  BtnCOM.Caption := 'COM'+ IntToStr(SerIICSlv.Comport);
  Statusbar1.Panels[0].Text := 'COMPort open' ;
end;

procedure TForm1.SerIICSlvClose(Sender: TObject);
begin
  BtnCOM.Caption := 'COM?';
  Statusbar1.Panels[0].Text := 'COMPort closed' ;
end;

procedure TForm1.SerIICSlvTimeOut(Sender: TObject);
begin
  Statusbar1.Panels[0].Text := 'ERROR: TimeOut' ;
  ShowMessage('TIMEOUT');
end;

procedure TForm1.BtnGetSlvAdrClick(Sender: TObject);
begin
  case SerIICSlv.FRequestSlvAdr of
    0: Statusbar1.Panels[0].Text := 'CMD sent';
    1: Statusbar1.Panels[0].Text := 'ERROR: ComPort is closed';
    2: Statusbar1.Panels[0].Text := 'Device Busy';
  end;
end;

procedure TForm1.BtnSSlvAdrClick(Sender: TObject);
begin
  case SerIICSlv.FSaveSlvAdr of
    0: Statusbar1.Panels[0].Text := 'CMD sent' ;
    1: Statusbar1.Panels[0].Text := 'ERROR: ComPort is closed' ;
    2: Statusbar1.Panels[0].Text := 'Device Busy' ;
  end;
end;

procedure TForm1.BtnCSlvAdrClick(Sender: TObject);
var i : Byte;
begin
  i := StrToInt('$'+InSlvAdr.Text);
  case SerIICSlv.FSetSlvAdr(i) of
    0: Statusbar1.Panels[0].Text := 'CMD sent' ;
    1: Statusbar1.Panels[0].Text := 'ERROR: ComPort is closed' ;
    2: Statusbar1.Panels[0].Text := 'Device Busy' ;
  end;
end;

procedure TForm1.SerIICSlvSlvAdrOP(Sender: TObject; OP: Byte);
begin
  case OP of
  1 : Statusbar1.Panels[0].Text := 'Slave Adress changed';
  2 : Statusbar1.Panels[0].Text := 'Slave Adress saved';
  end;
end;

procedure TForm1.SerIICSlvSlvAdrRead(Sender: TObject; pSlvAdr: Byte);
begin
  InSlvAdr.Text := IntToHex(pSlvAdr,2);
  Statusbar1.Panels[0].Text := 'Slave Adress received' ;
end;

procedure TForm1.SerIICSlvI2CDataAvail(Sender: TObject; I2CData: TI2CData);
var i : Byte;
    Stri : String;
begin
  Stri := '';
  for i := 0 to I2CData.iLen -1 do
    Stri := Stri + '['+IntToHex(I2CData.iData[i],2)+'] ';
  Memo1.Lines.Add(Stri);
  Statusbar1.Panels[0].Text := 'Data received';
end;

procedure TForm1.BtnWDataClick(Sender: TObject);
var sData : String;
    iData : Array of Byte;
    i,k   : Byte;
    Len   : Integer;
    int   : Byte;
begin
  sData := EditWrite.Text;
  Len   := Length(sData);
  SetLength(iData, Len DIV 2);
  k := 0;
  i := 1;
  While i <= Len - 1 do
  begin
    iData[k] := StrToInt('$'+Copy(sData,i,2));
    i := i + 2;
    inc(k);
  end;
  if RBNoInt.Checked then int := 0 else
  if RBInt1.Checked  then int := 1 else
  if RBInt2.Checked  then int := 2 else int := 0;
  case SerIICSlv.FWriteI2CRegs(iData,int) of
    0 : Statusbar1.Panels[0].Text := 'Write_CMD' ;
    1 : Statusbar1.Panels[0].Text := 'ERROR: COMPORT CLOSED' ;
    2 : Statusbar1.Panels[0].Text := 'I2C BUSY';
  end
end;

procedure TForm1.SerIICSlvWriteI2CRegs(Sender: TObject; IntType: Byte);
begin
  case IntType of
    0: Statusbar1.Panels[0].Text := 'Data write without Interrupt';
    1: Statusbar1.Panels[0].Text := 'Data write with Interrupt 1';
    2: Statusbar1.Panels[0].Text := 'Data write with Interrupt 2';
  end;
end;

procedure TForm1.HexKey(var Key: Char);
begin
  if Key = 'a' then Key := 'A';
  if Key = 'b' then Key := 'B';
  if Key = 'c' then Key := 'C';
  if Key = 'd' then Key := 'D';
  if Key = 'e' then Key := 'E';
  if Key = 'f' then Key := 'F';
  if not (Key in [#8,#13,'0','1','2','3','4','5','6','7','8','9',
                  'A','B','C','D','E','F']) then Key := #0;
end;

procedure TForm1.InSlvAdrExit(Sender: TObject);
begin
  if InSlvAdr.Text = '' then
    InSlvAdr.Text := '00'
  else if Length(InSlvAdr.Text) = 1 then
    InSlvAdr.Text := '0'+ InSlvAdr.Text;
end;

procedure TForm1.InSlvAdrKeyPress(Sender: TObject; var Key: Char);
begin
  HexKey(Key);
end;

procedure TForm1.EditWriteKeyPress(Sender: TObject; var Key: Char);
begin
  HexKey(Key);
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  if InComNr.Text <> '' then
    SerIICSlv.Comport := StrToInt(InComNr.Text)
end;

end.
